﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System;
using CookComputing.XmlRpc;

namespace Bazaar
{
    /// <summary>
    /// An Interface that allows using XMLRPC to functions to the Bazaar Server
    /// </summary>
    [XmlRpcUrl("http://localhost:11113")]
    public interface IClient : IXmlRpcProxy
    {
        [XmlRpcMethod("run_bzr")]
        object[] Run(string[] argumentValues, string workingDirectory);

        [XmlRpcMethod("run_bzr_command")]
        object[] RunCommand(string[] argumentValues, string workingDirectory);

        [XmlRpcMethod("list_methods")]
        String[] ListMethods();

        [XmlRpcMethod("quit")]
        int Quit();
    }
}
