﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

namespace Bazaar.Commands
{
    public class CommandOption
    {
        protected string m_name;

        public CommandOption(string name)
        {
            this.m_name = name;
        }

        /// <summary>
        /// The command option
        /// </summary>
        public string Name
        {
            get { return this.m_name; }
            set { this.m_name = value; }
        }

        public override bool Equals(object obj)
        {
            if (obj == null)
            {
                return false;
            }

            if (obj.GetType() == typeof(CommandOption))
            {
                CommandOption other = (CommandOption)obj;
                return m_name == other.m_name;
            }
            return false;
        }

        public static bool operator== (CommandOption self, CommandOption other)
        {
            if (self == null || other == null)
            {
                return true;
            }
            return self.Equals(other);
        }

        public static bool operator !=(CommandOption self, CommandOption other)
        {
            if (self == null || other == null)
            {
                return true;
            }
            return !self.Equals(other);
        }

        public override string ToString()
        {
            return " " + m_name;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}
