﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System.Collections.Generic;
using System.IO;

namespace Bazaar.Commands
{
    public class Init : SingleFile
    {
        public Init(FileInfo file)
            : base(file.Directory, file)
        {
            name = "init";
        }

        public Init(DirectoryInfo directory)
            : base(directory)
        {
            name = "init";
        }

        public override IList<string> Arguments
        {
            get
            {
                IList<string> arguments = base.Arguments;
                if (file != null)
                {
                    arguments.Add(file.MakeRelativeUri(workingDirectory).ToString());
                }
                return arguments;
            }
        }
    }
}
