﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

namespace Bazaar.Commands
{
    public class KeywordOption : CommandOption
    {
        private string argument;

        public KeywordOption(string name) : base(name) { }

        public KeywordOption(string name, string argument) : base(name) { this.argument = argument; }

        public string Argument
        {
            get { return argument; }
            set { argument = value; }
        }

        public override string ToString()
        {
            if (argument != null)
            {
                return m_name + "=" + argument;
            }
            else
            {
                return m_name + "=?";
            }
        }
    }
}
