﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Bazaar.Commands
{
    public abstract class Remote : Command
    {
        private Uri location;

        public Remote(DirectoryInfo directory, Uri location)
            : base(directory)
        {
            if (location == null)
            {
                throw new BazaarException("Null location provided for " + name);
            }
            this.location = location;
        }

        public override IList<string> Arguments
        {
            get
            {
                IList<string> args = base.Arguments;
                if (!String.IsNullOrEmpty(location.AbsoluteUri))
                {
                    args.Add(location.AbsoluteUri);
                }
                return args;
            }
        }
    }
}
