﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System.Collections.Generic;
using System.IO;
using System.Linq;
using Bazaar.Results;

namespace Bazaar.Commands
{
    public class Status : MultipleFile
    {
        public Status(DirectoryInfo directory, IList<FileSystemInfo> files)
            : base(directory, files)
        {
            name = "xmlstatus";
        }

        public Status(DirectoryInfo directory)
            : base(directory)
        {
            name = "xmlstatus";
        }

        public Status(string directory, IEnumerable<string> files)
            : base(directory, files)
        {
            name = "xmlstatus";
        }

        public override IEnumerable<IResult> Results
        {
            get
            {
                return Parser.Status(response.Data).Cast<IResult>();
            }
        }

        public WorkingTree WorkingTree
        {
            get
            {
                return new WorkingTree(workingDirectory,
                    Parser.Status(Response.Data).ToDictionary(x => x.Code, x => x));
            }
        }
    }
}
