﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System.IO;

namespace Bazaar.Results
{
    public class FileStatus : IResult
    {
        private StatusCode code;
        private DirectoryInfo root;
        private string fileName;

        public StatusCode Code
        {
            get { return code; }
            set { code = value; }
        }

        public DirectoryInfo Root
        {
            get { return root; }
            set { root = value; }
        }

        public string FileName
        {
            get { return fileName; }
            set { fileName = value; }
        }

        public override string ToString()
        {
            return code.ToString() + " " + fileName;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}
