// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System;
using System.IO;
namespace Bazaar.Results
{
	public class Item : IResult
	{
		private string id;
		private Kind kind;
		private string fileName;
		private SourceControl status;
        private DirectoryInfo root;

        public DirectoryInfo Root
        {
            get { return root; }
            set { root = value; }
        }

		public SourceControl Status
		{
			get { return status; }
			set { status = value; }
		}

		public Kind Kind
		{
			get { return kind; }
			set { kind = value; }
		}


		public string Id
		{
			get { return id; }
			set { id = value; }
		}

		public string FileName
		{
			get { return fileName; }
			set { fileName = value; }
		}

        public override bool Equals(object obj)
        {
            if (obj == null)
            {
                return false;
            }

            Item item = (Item)obj;

            if (item == null)
            {
                return false;
            }

            return item.id == id;
        }

        public static bool operator ==(Item self, Item other)
        {
            if(other == null || self == null)
            {
                return false;
            }

            return self.id == other.id;
        }

        public static bool operator !=(Item self, Item other)
        {
            if (other == null || self == null)
            {
                return true;
            }

            return self.id != other.id;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
	}
}
