﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System.Collections.Generic;
using System.IO;

namespace Bazaar.Results
{
    public class LogMessage : IResult
    {
        private string nick;
        private int revision;
        private string message;
        private string committer;
        private string timestamp;
        private IList<FileStatus> files = new List<FileStatus>();
        private IList<LogMessage> merged = new List<LogMessage>();
        private DirectoryInfo root;

        public DirectoryInfo Root
        {
            get { return root; }
            set { root = value; }
        }

        #region Accessor Properties

        public IList<LogMessage> Merged
        {
            get { return merged; }
        }

        public string Timestamp
        {
            get { return timestamp; }
            set { timestamp = value; }
        }

        public IList<FileStatus> Files
        {
            get { return files; }
        }

        public string Committer
        {
            get { return committer; }
            set { committer = value; }
        }

        public int Revision
        {
            get { return revision; }
            set { revision = value; }
        }

        public string Nick
        {
            get { return nick; }
            set { nick = value; }
        }

        public string Message
        {
            get { return message; }
            set { message = value; }
        } 
        #endregion
    }
}
