﻿// BzrSharp
// Copyright (C) 2010  Carlos Flores <cafg10@gmail.com>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

using System.Text;
using System.Globalization;

namespace Bazaar.Results
{
    public class Response
    {
        private string error;
        private int exitCode;
        private string data;

        public Response(object[] value)
        {
            if (value == null)
            {
                throw new BazaarException("Empty Response Array");
            }
            exitCode = (int)value[0];
            data = Encoding.UTF8.GetString((byte[])value[1]);
            error = (string)value[2];
        }

        public Response()
        {
            exitCode = -1;
        }

        #region Attribute Accessors
        public string Error
        {
            get { return error; }
            set { error = value; }
        }

        public int ExitCode
        {
            get { return exitCode; }
            set { exitCode = value; }
        }

        public string Data
        {
            get { return data; }
            set { data = value; }
        }
        #endregion

        public override string ToString()
        {
            string message = "Response: ";

            message += "\nExit Code: " + exitCode.ToString(CultureInfo.InvariantCulture) + " Error Flags: " + error + "\n";
            message += data;

            return message;
        }
    }
}
